`include "inc/noc.svh"
`include "inc/noc_CIRCULANT.svh"
`include "noc/noc.sv"


module toplevel (
    input clk,
    input[0:`PL-1] packet,
    input[`CS-1:0] core_NO,
    input core_availability_signals_out[0:`RN-1],
    output core_availability_signals_in[0:`RN-1],
    output wire[0:1] core_inputs_2_bits[0:`RN-1]
);

    wire[0:`PL-1] core_inputs[0:`RN-1];
    wire[0:`PL-1] core_outputs[0:`RN-1];

    generate
        genvar i;

        for (i = 0; i < `RN; i = i + 1)
        begin : bool_grid
            assign core_inputs_2_bits[i] = {core_inputs[i][0], ^core_inputs[i]};
        end

    endgenerate

    dataSelector selector(.clk(clk), .packet(packet), .core_NO(core_NO), .core_outputs(core_outputs));

    noc noc(
        .clk(clk),
        .core_inputs(core_inputs),
        .core_outputs(core_outputs),
        .core_availability_signals_out(core_availability_signals_out),
        .core_availability_signals_in(core_availability_signals_in)
    );
    
endmodule


module dataSelector (
    input clk,
    input[0:`PL-1] packet,
    input[`CS-1:0] core_NO,
    output reg[0:`PL-1] core_outputs[0:`RN-1]
);

	initial begin
        int i;
        for (i = 0; i < `RN; i = i + 1)
        begin
            core_outputs[i] = 0;
        end
    end

    always @(posedge clk) begin
        core_outputs[core_NO] <= packet;
    end
    
endmodule