`include "inc/router.svh"
`include "src/queue.sv"
`include "src/arbiter.sv"
`include "src/algorithm.sv"

module router (
    {0}
);

    wire[0:`PL-1] queue_to_arbiter[0:`REN-1];
    wire[0:`PL-1] arbiter_to_algorithm;
    wire shift_signals[0:`REN-1];
    wire[`REN_B-1:0] shift;
    wire send_data_flag;


    generate
        genvar i;
        for (i=0; i<`REN; i=i+1) begin : queues_initialiser
            queue queue_i (.clk(clk),
            .data_in(inputs[i]), .data_out(queue_to_arbiter[i]),
            .availability_signal(signals_out[i]), .shift_signal(shift_signals[i]));
        end
    endgenerate


    arbiter round_robin(.clk(clk),
    .input_(queue_to_arbiter), .output_data(arbiter_to_algorithm),
    .shift(shift)
    );

    {1}

    
endmodule
