`include "src/router.sv"
`include "inc/queue.svh"
`include "inc/noc.svh"
`include "inc/router.svh"
`timescale 1ns/1ns


module tb_queueing;


reg clk = 0;
reg[0:`PL-1] inputs[0:`REN-1];
wire[0:`PL-1] outputs[0:`REN-1];
reg signals_in[0:`REN-1];
wire signals_out[0:`REN-1];
reg[`CS-1:0] router_NO = `RN / 2;

reg[`CS-1:0] destination_NO[0:4] = {router_NO, router_NO - `LT, router_NO - 1, router_NO + 1, router_NO + `LT};

integer i;
integer j;
reg[0:`PL-1] packet;
reg[`PL - `CS - 2:0] info;

router DUT (
    clk,
    inputs, outputs,
    signals_in, signals_out,
    router_NO
);

localparam CLK_PERIOD = 10;
always #(CLK_PERIOD/2) clk=~clk;


initial begin
    
    for (i = 0; i < `REN; i = i + 1)
    begin
        signals_in[i] = 0;
        inputs[i] = 0;
    end

    for (i = 0; i < `REN; i = i + 1)
    begin

        for (j = 0; j < `EN * 2; j = j + 1) // testing with overflow
        begin
            info = (i+1) * (j+1);
            packet = {1'b1, destination_NO[i], info};
            @(posedge clk)
            begin
                inputs[0] <= packet;
            end
        end

    end

    @(posedge clk)
    begin
        inputs[0] <= 0;
    end

    for (i = 0; i < `REN; i = i + 1)
    begin
        signals_in[i] = 1;
    end

    for (j = 0; j < `EN; j = j + 1)
    begin
        @(posedge clk)
        begin
            for (i = 0; i < `REN; i = i + 1)
            begin
                info = (i+1) * (j+1);
                packet = {1'b1, destination_NO[i], info};
                assert (outputs[i] == packet) else $error("Packet %b not to be seen", packet);
            end
        end
    end
    $finish;
end

endmodule