﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HDLNoCGen
{
    public class ProjectMetadata
    {
        public string name { get; set; }

        public ProjectMetadata ()
        {
            name = "";
        }
    }
    public class GraphVerilogMetadata
    {
        public bool graphSerialized { get; set; }
        public bool verilogGenerated { get; set; }

        public GraphVerilogMetadata ()
        {
            graphSerialized = false;
            verilogGenerated = false;
        }
    }
    public class QuartusMetadata
    {
        public bool quartusCompiled { get; set; }
        public string deviceName { get; set; }

        public QuartusMetadata ()
        {
            quartusCompiled = false;
            deviceName = "5CGXFC9E7F35C8";
        }
    }
    public class DatabaseMetadata
    {
        public string dbIp { get; set; }
        public string dbUsername { get; set; }
        public string dbPassword { get; set; }
        public string dbName { get; set; }
        public int dbPort { get; set; }
        public bool writtenToDB { get; set; }

        public DatabaseMetadata ()
        {
            dbIp = "";
            dbUsername = "";
            dbPassword = "";
            dbName = "";
            dbPort = -1;
            writtenToDB = false;
        }
    }
    public class ProjectSettings
    {
        public ProjectMetadata projectMetadata { get; set; }
        public GraphVerilogMetadata graphVerilogMetadata { get; set; }
        public QuartusMetadata quartusMetadata { get; set; }
        public DatabaseMetadata databaseMetadata { get; set; }

        public ProjectSettings ()
        {
            projectMetadata = new ProjectMetadata ();
            graphVerilogMetadata = new GraphVerilogMetadata ();
            quartusMetadata = new QuartusMetadata ();
            databaseMetadata = new DatabaseMetadata ();
        }
    }
}
